diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java b/src/main/java/net/minecraft/client/render/block/model/FireBlockModel.java
similarity index 92%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
rename to src/main/java/net/minecraft/client/render/block/model/FireBlockModel.java
index 56fae4788..c5030e9a7 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
+++ b/src/main/java/net/minecraft/client/render/block/model/FireBlockModel.java
@@ -1,20 +1,21 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFire;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.FireBlock;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelFire<T extends Block> extends BlockModelStandard<T>{
+public class FireBlockModel<T extends Block> extends StandardBlockModel<T> {
     private final boolean overrideRender;
-    public BlockModelFire(Block block) {
+    public FireBlockModel(Block block) {
         this(block, false);
     }
 
-    public BlockModelFire(Block block, boolean overrideRender) {
+    public FireBlockModel(Block block, boolean overrideRender) {
         super(block);
         this.overrideRender = overrideRender;
     }
@@ -39,7 +40,7 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T>{
         double vMin = tex.getIconVMin();
         double vMax = tex.getIconVMax();
         final float yOffset = 1.4F;
-        if(overrideRender || renderBlocks.blockAccess.isBlockNormalCube(x, y - 1, z) || ((BlockFire)Block.fire).canBlockCatchFire(renderBlocks.blockAccess, x, y - 1, z))
+        if(overrideRender || renderBlocks.blockAccess.isBlockNormalCube(x, y - 1, z) || ((FireBlock)Blocks.FIRE).canBurn(renderBlocks.blockAccess, x, y - 1, z))
         {
             double d8 = (double)x + 0.5D + 0.2D;
             double d9 = ((double)x + 0.5D) - 0.2D;
@@ -114,7 +115,7 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T>{
                 uMax = uMin;
                 uMin = d10;
             }
-            if(((BlockFire)Block.fire).canBlockCatchFire(renderBlocks.blockAccess, x - 1, y, z))
+            if(((FireBlock)Blocks.FIRE).canBurn(renderBlocks.blockAccess, x - 1, y, z))
             {
                 tessellator.addVertexWithUV((float)x + f3, (float)y + yOffset + f4, z + 1, uMax, vMin);
                 tessellator.addVertexWithUV(x, (float)(y) + f4, z + 1, uMax, vMax);
@@ -125,7 +126,7 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T>{
                 tessellator.addVertexWithUV(x, (float)(y) + f4, z + 1, uMax, vMax);
                 tessellator.addVertexWithUV((float)x + f3, (float)y + yOffset + f4, z + 1, uMax, vMin);
             }
-            if(((BlockFire)Block.fire).canBlockCatchFire(renderBlocks.blockAccess, x + 1, y, z))
+            if(((FireBlock)Blocks.FIRE).canBurn(renderBlocks.blockAccess, x + 1, y, z))
             {
                 tessellator.addVertexWithUV((float)(x + 1) - f3, (float)y + yOffset + f4, z, uMin, vMin);
                 tessellator.addVertexWithUV((x + 1), (float)(y) + f4, z, uMin, vMax);
@@ -136,7 +137,7 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T>{
                 tessellator.addVertexWithUV((x + 1), (float)(y) + f4, z, uMin, vMax);
                 tessellator.addVertexWithUV((float)(x + 1) - f3, (float)y + yOffset + f4, z, uMin, vMin);
             }
-            if(((BlockFire)Block.fire).canBlockCatchFire(renderBlocks.blockAccess, x, y, z - 1))
+            if(((FireBlock)Blocks.FIRE).canBurn(renderBlocks.blockAccess, x, y, z - 1))
             {
                 tessellator.addVertexWithUV(x, (float)y + yOffset + f4, (float)z + f3, uMax, vMin);
                 tessellator.addVertexWithUV(x, (float)(y) + f4, z, uMax, vMax);
@@ -147,7 +148,7 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T>{
                 tessellator.addVertexWithUV(x, (float)(y) + f4, z, uMax, vMax);
                 tessellator.addVertexWithUV(x, (float)y + yOffset + f4, (float)z + f3, uMax, vMin);
             }
-            if(((BlockFire)Block.fire).canBlockCatchFire(renderBlocks.blockAccess, x, y, z + 1))
+            if(((FireBlock)Blocks.FIRE).canBurn(renderBlocks.blockAccess, x, y, z + 1))
             {
                 tessellator.addVertexWithUV(x + 1, (float)y + yOffset + f4, (float)(z + 1) - f3, uMin, vMin);
                 tessellator.addVertexWithUV(x + 1, (float)(y) + f4, (z + 1), uMin, vMax);
@@ -158,7 +159,7 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T>{
                 tessellator.addVertexWithUV(x + 1, (float)(y) + f4, (z + 1), uMin, vMax);
                 tessellator.addVertexWithUV(x + 1, (float)y + yOffset + f4, (float)(z + 1) - f3, uMin, vMin);
             }
-            if(((BlockFire)Block.fire).canBlockCatchFire(renderBlocks.blockAccess, x, y + 1, z))
+            if(((FireBlock)Blocks.FIRE).canBurn(renderBlocks.blockAccess, x, y + 1, z))
             {
                 double d11 = (double)x + 0.5D + 0.5D;
                 double d13 = ((double)x + 0.5D) - 0.5D;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCherryLeavesBloom.java b/src/main/java/net/minecraft/client/render/block/model/FloweringCherryLeavesBlockModel.java
similarity index 85%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelCherryLeavesBloom.java
rename to src/main/java/net/minecraft/client/render/block/model/FloweringCherryLeavesBlockModel.java
index b58434ea2..f38dda9c1 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCherryLeavesBloom.java
+++ b/src/main/java/net/minecraft/client/render/block/model/FloweringCherryLeavesBlockModel.java
@@ -1,16 +1,17 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.FloweringCherryLeavesBlock;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelCherryLeavesBloom<T extends Block> extends BlockModelLeaves<T> {
+public class FloweringCherryLeavesBlockModel<T extends Block> extends LeavesBlockModel<T> {
     private final IconCoordinate grownCherryOverlay = TextureRegistry.getTexture("minecraft:block/leaves_cherry_overlay");
     private final IconCoordinate floweringCherryOverlay = TextureRegistry.getTexture("minecraft:block/leaves_cherry_flowering_overlay");
-    public BlockModelCherryLeavesBloom(Block block) {
+    public FloweringCherryLeavesBlockModel(Block block) {
         super(block, "minecraft:block/leaves_cherry");
     }
 
@@ -18,7 +19,7 @@ public class BlockModelCherryLeavesBloom<T extends Block> extends BlockModelLeav
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         super.render(tessellator, x, y, z);
 
-        int growthRate = (renderBlocks.blockAccess.getBlockMetadata(x, y, z) & 0XF0) >> 4;
+        int growthRate = FloweringCherryLeavesBlock.getGrowthRate(renderBlocks.blockAccess.getBlockMetadata(x, y, z));
         if(growthRate > 0) {
             renderBlocks.overrideBlockTexture = grownCherryOverlay;
         } else {
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/src/main/java/net/minecraft/client/render/block/model/FluidBlockModel.java
similarity index 94%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
rename to src/main/java/net/minecraft/client/render/block/model/FluidBlockModel.java
index ff56d4b7c..648c2abbc 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/src/main/java/net/minecraft/client/render/block/model/FluidBlockModel.java
@@ -2,17 +2,17 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFluid;
+import net.minecraft.core.block.FluidBlock;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelFluid(Block block) {
+public class FluidBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public FluidBlockModel(Block block) {
         super(block);
     }
 
@@ -46,15 +46,15 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
         final float yOff = 0.001f;
         Material material = block.blockMaterial;
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        float f7 = BlockFluid.getFluidHeight(renderBlocks.blockAccess, x, y, z, material);
-        float f8 = BlockFluid.getFluidHeight(renderBlocks.blockAccess, x, y, z + 1, material);
-        float f9 = BlockFluid.getFluidHeight(renderBlocks.blockAccess, x + 1, y, z + 1, material);
-        float f10 = BlockFluid.getFluidHeight(renderBlocks.blockAccess, x + 1, y, z, material);
+        float f7 = FluidBlock.getFluidHeight(renderBlocks.blockAccess, x, y, z, material);
+        float f8 = FluidBlock.getFluidHeight(renderBlocks.blockAccess, x, y, z + 1, material);
+        float f9 = FluidBlock.getFluidHeight(renderBlocks.blockAccess, x + 1, y, z + 1, material);
+        float f10 = FluidBlock.getFluidHeight(renderBlocks.blockAccess, x + 1, y, z, material);
         if(renderBlocks.renderAllFaces || renderTop)
         {
             didRender = true;
             IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.TOP, meta);
-            float rotation = (float) BlockFluid.getSlopeAngle(renderBlocks.blockAccess, x, y, z, material);
+            float rotation = (float) FluidBlock.getSlopeAngle(renderBlocks.blockAccess, x, y, z, material);
             if(rotation > -999F)
             {
                 texture = getBlockTextureFromSideAndMetadata(Side.NORTH, meta);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorGlass.java b/src/main/java/net/minecraft/client/render/block/model/GlassDoorBlockModel.java
similarity index 61%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelDoorGlass.java
rename to src/main/java/net/minecraft/client/render/block/model/GlassDoorBlockModel.java
index d52dce33a..2e7b055ad 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorGlass.java
+++ b/src/main/java/net/minecraft/client/render/block/model/GlassDoorBlockModel.java
@@ -1,11 +1,11 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockDoor;
+import net.minecraft.core.block.DoorBlock;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelDoorGlass<T extends BlockDoor> extends BlockModelDoor<T>{
-    public BlockModelDoorGlass(Block block) {
+public class GlassDoorBlockModel<T extends DoorBlock> extends DoorBlockModel<T> {
+    public GlassDoorBlockModel(Block block) {
         super(block);
     }
     @Override
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java b/src/main/java/net/minecraft/client/render/block/model/GrassBlockModel.java
similarity index 95%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
rename to src/main/java/net/minecraft/client/render/block/model/GrassBlockModel.java
index dc0ae1411..365741006 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
+++ b/src/main/java/net/minecraft/client/render/block/model/GrassBlockModel.java
@@ -2,8 +2,8 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
@@ -13,7 +13,7 @@ import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelGrass<T extends Block> extends BlockModelStandard<T> {
+public class GrassBlockModel<T extends Block> extends StandardBlockModel<T> {
     public static boolean useOverlay = false;
     private static final IconCoordinate[] overlayIndices = new IconCoordinate[]{
             null,
@@ -23,7 +23,7 @@ public class BlockModelGrass<T extends Block> extends BlockModelStandard<T> {
             TextureRegistry.getTexture("minecraft:block/grass_side_overlay"),
             TextureRegistry.getTexture("minecraft:block/grass_side_overlay")};
     protected IconCoordinate snowSide = TextureRegistry.getTexture("minecraft:block/grass_snowy_side");
-    public BlockModelGrass(Block block) {
+    public GrassBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java b/src/main/java/net/minecraft/client/render/block/model/HorizontalRotationBlockModel.java
similarity index 71%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java
rename to src/main/java/net/minecraft/client/render/block/model/HorizontalRotationBlockModel.java
index 19c721a87..6187733eb 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java
+++ b/src/main/java/net/minecraft/client/render/block/model/HorizontalRotationBlockModel.java
@@ -1,12 +1,12 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
 
-public class BlockModelHorizontalRotation<T extends Block> extends BlockModelStandard<T>{
-    public BlockModelHorizontalRotation(Block block) {
+public class HorizontalRotationBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public HorizontalRotationBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelIce.java b/src/main/java/net/minecraft/client/render/block/model/IceBlockModel.java
similarity index 75%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelIce.java
rename to src/main/java/net/minecraft/client/render/block/model/IceBlockModel.java
index 1dd6af6ef..f0793e134 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelIce.java
+++ b/src/main/java/net/minecraft/client/render/block/model/IceBlockModel.java
@@ -3,8 +3,8 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelIce<T extends Block> extends BlockModelTransparent<T> {
-    public BlockModelIce(Block block) {
+public class IceBlockModel<T extends Block> extends TransparentBlockModel<T> {
+    public IceBlockModel(Block block) {
         super(block, false);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java b/src/main/java/net/minecraft/client/render/block/model/JarBlockModel.java
similarity index 96%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
rename to src/main/java/net/minecraft/client/render/block/model/JarBlockModel.java
index 28869cd8a..2add4dbee 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
+++ b/src/main/java/net/minecraft/client/render/block/model/JarBlockModel.java
@@ -1,16 +1,16 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelJar<T extends Block> extends BlockModelStandard<T> {
+public class JarBlockModel<T extends Block> extends StandardBlockModel<T> {
     protected IconCoordinate jarEmpty = TextureRegistry.getTexture("minecraft:block/jar");
     protected IconCoordinate jarFull = TextureRegistry.getTexture("minecraft:block/jar_dirt");
-    public BlockModelJar(Block block) {
+    public JarBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java b/src/main/java/net/minecraft/client/render/block/model/LadderBlockModel.java
similarity index 94%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
rename to src/main/java/net/minecraft/client/render/block/model/LadderBlockModel.java
index 7bf61368c..cb1537d4b 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLadder.java
+++ b/src/main/java/net/minecraft/client/render/block/model/LadderBlockModel.java
@@ -1,13 +1,13 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelLadder<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelLadder(Block block) {
+public class LadderBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public LadderBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/LampBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/LampBlockModel.java
new file mode 100644
index 000000000..aeb0d8e59
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/LampBlockModel.java
@@ -0,0 +1,42 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.LampBlock;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+
+public class LampBlockModel<T extends LampBlock> extends StandardBlockModel<T> {
+    private static final IconCoordinate[] texCoordsInactive = new IconCoordinate[DyeColor.COLOR_AMOUNT];
+    private static final IconCoordinate[] texCoordsActive = new IconCoordinate[DyeColor.COLOR_AMOUNT];
+
+    static {
+        for (DyeColor c : DyeColor.blockOrderedColors()){
+            texCoordsInactive[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/lamp_" + c.colorID + "_idle");
+            texCoordsActive[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/lamp_" + c.colorID + "_active");
+        }
+    }
+
+    public LampBlockModel(Block block) {
+        super(block);
+    }
+
+    @Override
+    public IconCoordinate getBlockTexture(WorldSource worldSource, int x, int y, int z, Side side)
+    {
+        int color = worldSource.getBlockMetadata(x, y, z) & DyeColor.MASK_COLOR;
+        if (block.isActive) {
+            return texCoordsActive[color];
+        } else {
+            return texCoordsInactive[color];
+        }
+    }
+
+    @Override
+    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    {
+        return texCoordsActive[data & DyeColor.MASK_COLOR];
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java b/src/main/java/net/minecraft/client/render/block/model/LanternBlockModel.java
similarity index 98%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
rename to src/main/java/net/minecraft/client/render/block/model/LanternBlockModel.java
index 791781b79..a0197810e 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
+++ b/src/main/java/net/minecraft/client/render/block/model/LanternBlockModel.java
@@ -1,13 +1,13 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelLantern<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelLantern(Block block) {
+public class LanternBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public LanternBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java b/src/main/java/net/minecraft/client/render/block/model/LayerBlockModel.java
similarity index 89%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
rename to src/main/java/net/minecraft/client/render/block/model/LayerBlockModel.java
index f6719d342..7eb176bc7 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
+++ b/src/main/java/net/minecraft/client/render/block/model/LayerBlockModel.java
@@ -6,8 +6,8 @@ import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelLayer<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelLayer(Block block) {
+public class LayerBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public LayerBlockModel(Block block) {
         super(block);
         withCustomItemBounds(0.0f, 0.0f, 0.0f, 1.0f, 2 / 16F, 1.0f);
     }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java b/src/main/java/net/minecraft/client/render/block/model/LeavesBlockModel.java
similarity index 79%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
rename to src/main/java/net/minecraft/client/render/block/model/LeavesBlockModel.java
index bb44de04c..cccb0ff69 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
+++ b/src/main/java/net/minecraft/client/render/block/model/LeavesBlockModel.java
@@ -1,16 +1,16 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelLeaves<T extends Block> extends BlockModelStandard<T> {
+public class LeavesBlockModel<T extends Block> extends StandardBlockModel<T> {
     protected static boolean fancyGraphics;
     protected final IconCoordinate fancyLeavesTexture;
 
-    public BlockModelLeaves(Block block, String leavesTex) {
+    public LeavesBlockModel(Block block, String leavesTex) {
         super(block);
         withTextures(leavesTex);
         fancyLeavesTexture = TextureRegistry.getTexture(leavesTex + "_fancy");
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesOverlay.java b/src/main/java/net/minecraft/client/render/block/model/LeavesOverlayBlockModel.java
similarity index 89%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesOverlay.java
rename to src/main/java/net/minecraft/client/render/block/model/LeavesOverlayBlockModel.java
index 6e13d8f7e..e0a07750b 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesOverlay.java
+++ b/src/main/java/net/minecraft/client/render/block/model/LeavesOverlayBlockModel.java
@@ -1,15 +1,15 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelLeavesOverlay<T extends Block> extends BlockModelLeaves<T> {
+public class LeavesOverlayBlockModel<T extends Block> extends LeavesBlockModel<T> {
     protected final IconCoordinate overlayTexture;
-    public BlockModelLeavesOverlay(Block block, String leavesTex, String overlayTex) {
+    public LeavesOverlayBlockModel(Block block, String leavesTex, String overlayTex) {
         super(block, leavesTex);
         overlayTexture = TextureRegistry.getTexture(overlayTex);
     }
